# NGINX server configuration managed by CHEF. All changes will be overwritten.
#
# depends on gitweb and fcgiwrap packages

<% if @proxy_ssl %>
server {
  listen 80;
  server_name <%= @proxy_fqdn %>;
<% if @proxy_ssl == true %>
  include <%= @acme_conf %>;
<% end %>
  location / {
    return 301 https://<%= @proxy_fqdn %>$request_uri;
  }
}
<% end %>

server {
  listen <%= @proxy_ssl ? '443 ssl default_server' : '80 default_server' %>;

	server_name _;

  server_tokens off;     # don't show the version number, a security best practice

	<% if @proxy_ssl %>
	  ssl_certificate <%= @ssl_crt %>;
	  ssl_certificate_key <%= @ssl_key %>;
	<% end %>

	location / {
    <% if node['spielplatz']['oauth2_proxy']['enabled'] %>
    auth_request /oauth2/auth;
    error_page 401 = /oauth2/sign_in;

    # pass information via X-User and X-Email headers to backend,
    # requires running with --set-xauthrequest flag
    auth_request_set $user   $upstream_http_x_auth_request_user;
    auth_request_set $email  $upstream_http_x_auth_request_email;
    proxy_set_header X-User  $user;
    proxy_set_header X-Email $email;

    # if you enabled --cookie-refresh, this is needed for it to work with auth_request
    auth_request_set $auth_cookie $upstream_http_set_cookie;
    add_header Set-Cookie $auth_cookie;

    # When using the --set-authorization flag, some provider's cookies can exceed the 4kb
    # limit and so the OAuth2 Proxy splits these into multiple parts.
    # Nginx normally only copies the first `Set-Cookie` header from the auth_request to the response,
    # so if your cookies are larger than 4kb, you will need to extract additional cookies manually.
    auth_request_set $auth_cookie_name_upstream_1 $upstream_cookie_auth_cookie_name_1;

    # Extract the Cookie attributes from the first Set-Cookie header and append them
    # to the second part ($upstream_cookie_* variables only contain the raw cookie content)
    if ($auth_cookie ~* "(; .*)") {
        set $auth_cookie_name_0 $auth_cookie;
        set $auth_cookie_name_1 "auth_cookie_name_1=$auth_cookie_name_upstream_1$1";
    }

    # Send both Set-Cookie headers now if there was a second part
    if ($auth_cookie_name_upstream_1) {
        add_header Set-Cookie $auth_cookie_name_0;
        add_header Set-Cookie $auth_cookie_name_1;
    }
    <% end %>
      root /usr/share/gitweb;
      index gitweb.cgi;
	}

	<% if @proxy_ssl == true %>
  include <%= @acme_conf %>;
  <% end %>

<% if node['spielplatz']['oauth2_proxy']['enabled'] %>
  location /oauth2/ {
    proxy_pass       http://127.0.0.1:4180;
    proxy_set_header Host                    $host;
    proxy_set_header X-Real-IP               $remote_addr;
    proxy_set_header X-Scheme                $scheme;
    proxy_set_header X-Auth-Request-Redirect $request_uri;
  }
  location = /oauth2/auth {
    proxy_pass       http://127.0.0.1:4180;
    proxy_set_header Host             $host;
    proxy_set_header X-Real-IP        $remote_addr;
    proxy_set_header X-Scheme         $scheme;
    # nginx auth_request includes headers but not body
    proxy_set_header Content-Length   "";
    proxy_pass_request_body           off;
  }
<% end %>

  location /gitweb.cgi {
      include fastcgi_params;
      gzip off;
      fastcgi_param   SCRIPT_FILENAME  /usr/share/gitweb/gitweb.cgi;
      fastcgi_param   GITWEB_CONFIG  /etc/gitweb.conf;
      fastcgi_pass    unix:/var/run/fcgiwrap.socket;
  }
}
